#Fetches Weapon ID
function kazz.magecraft:weapons/category/technical/get_id/mainhand
function kazz.magecraft:weapons/category/technical/get_id/offhand

#Fetches XP Data
execute store result score @s kazzmc.xp_point run xp query @s points
execute store result score @s kazzmc.xp_level run xp query @s levels

#Weapon Ability
  #Sparkle Wand
execute if entity @s[scores={kazzmc.wp_id_mainhand=1,kazzmc.wp_cd1=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..3}] if score @s kazzmc.xp_level matches 10.. run function kazz.magecraft:weapons/types/wands/sparkle/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=1,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/wands/sparkle/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=1,kazzmc.wp_cd1=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/wands/sparkle/insufficient_xp

  #Mist Wand
execute if entity @s[scores={kazzmc.wp_id_mainhand=2,kazzmc.wp_cd2=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..7}] run function kazz.magecraft:weapons/types/wands/mist/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=2,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/wands/mist/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=2,kazzmc.wp_cd2=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/wands/mist/insufficient_xp

  #Shadow Wand
execute if entity @s[scores={kazzmc.wp_id_mainhand=3,kazzmc.wp_cd3=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..7}] run function kazz.magecraft:weapons/types/wands/shadow/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=3,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/wands/shadow/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=3,kazzmc.wp_cd3=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/wands/shadow/insufficient_xp

  #Emerald Wand
execute if entity @s[scores={kazzmc.wp_id_mainhand=4,kazzmc.wp_cd6=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..4}] run function kazz.magecraft:weapons/types/wands/emerald/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=4,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/wands/emerald/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=4,kazzmc.wp_cd6=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/wands/emerald/insufficient_xp

  #Amethyst Scepter
execute if entity @s[scores={kazzmc.wp_id_mainhand=5,kazzmc.wp_cd7=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..7}] if score @s kazzmc.xp_level matches 10.. run function kazz.magecraft:weapons/types/scepters/amethyst/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=5,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/scepters/amethyst/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=5,kazzmc.wp_cd7=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/scepters/amethyst/insufficient_xp

  #Emerald Scepter
execute if entity @s[scores={kazzmc.wp_id_mainhand=6,kazzmc.wp_cd8=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..8}] if score @s kazzmc.xp_level matches 10.. run function kazz.magecraft:weapons/types/scepters/emerald/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=6,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/scepters/emerald/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=6,kazzmc.wp_cd8=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/scepters/emerald/insufficient_xp

  #Pearl Scepter
execute if entity @s[scores={kazzmc.wp_id_mainhand=7,kazzmc.wp_cd9=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..9}] if score @s kazzmc.xp_level matches 15.. run function kazz.magecraft:weapons/types/scepters/pearl/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=7,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/scepters/pearl/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=7,kazzmc.wp_cd9=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/scepters/pearl/insufficient_xp

  #Luminous Scepter
execute if entity @s[scores={kazzmc.wp_id_mainhand=8,kazzmc.wp_cd10=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..6}] if score @s kazzmc.xp_level matches 15.. run function kazz.magecraft:weapons/types/scepters/luminous/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=8,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/scepters/luminous/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=8,kazzmc.wp_cd10=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/scepters/luminous/insufficient_xp

  #Crystal Staff
execute if entity @s[scores={kazzmc.wp_id_mainhand=9,kazzmc.wp_cd11=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..8}] if score @s kazzmc.xp_level matches 15.. run function kazz.magecraft:weapons/types/staves/crystal/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=9,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/staves/crystal/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=9,kazzmc.wp_cd11=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/staves/crystal/insufficient_xp

  #Prism Staff
execute if entity @s[scores={kazzmc.wp_id_mainhand=10,kazzmc.wp_cd12=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..10}] if score @s kazzmc.xp_level matches 15.. run function kazz.magecraft:weapons/types/staves/prism/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=10,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/staves/prism/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=10,kazzmc.wp_cd12=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/staves/prism/insufficient_xp

  #Tempest Staff
execute if entity @s[scores={kazzmc.wp_id_mainhand=11,kazzmc.wp_cd13=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..14}] run function kazz.magecraft:weapons/types/staves/tempest/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=11,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/staves/tempest/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=11,kazzmc.wp_cd13=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/staves/tempest/insufficient_xp

  #Staff of the Abyss
execute if entity @s[scores={kazzmc.wp_id_mainhand=12,kazzmc.wp_cd14=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..19}] if score @s kazzmc.xp_level matches 20.. run function kazz.magecraft:weapons/types/staves/abyss/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=12,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/staves/abyss/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=12,kazzmc.wp_cd14=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/staves/abyss/insufficient_xp

  #Staff of the Sea
execute if entity @s[scores={kazzmc.wp_id_mainhand=13,kazzmc.wp_cd15=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..17}] if score @s kazzmc.xp_level matches 20.. run function kazz.magecraft:weapons/types/staves/sea/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=13,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/staves/sea/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=13,kazzmc.wp_cd15=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/staves/sea/insufficient_xp

  #Starlight Staff
execute if entity @s[scores={kazzmc.wp_id_mainhand=14,kazzmc.wp_cd16=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..6}] if score @s kazzmc.xp_level matches 25.. run function kazz.magecraft:weapons/types/staves/starlight/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=14,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/staves/starlight/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=14,kazzmc.wp_cd16=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/staves/starlight/insufficient_xp

  #Flare Tome
execute if entity @s[scores={kazzmc.wp_id_mainhand=15,kazzmc.wp_cd17=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..2}] run function kazz.magecraft:weapons/types/tomes/flare/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=15,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/tomes/flare/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=15,kazzmc.wp_cd17=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/tomes/flare/insufficient_xp

  #Soulspark Tome
execute if entity @s[scores={kazzmc.wp_id_mainhand=16,kazzmc.wp_cd18=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..4}] run function kazz.magecraft:weapons/types/tomes/soulspark/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=16,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/tomes/soulspark/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=16,kazzmc.wp_cd18=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/tomes/soulspark/insufficient_xp

  #Withering Tome
execute if entity @s[scores={kazzmc.wp_id_mainhand=17,kazzmc.wp_cd19=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..18}] if score @s kazzmc.xp_level matches 15.. run function kazz.magecraft:weapons/types/tomes/withering/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=17,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/tomes/withering/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=17,kazzmc.wp_cd19=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/tomes/withering/insufficient_xp

  #Astral Codex
execute if entity @s[scores={kazzmc.wp_id_mainhand=18,kazzmc.wp_cd20=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..7}] if score @s kazzmc.xp_level matches 25.. run function kazz.magecraft:weapons/types/tomes/astral/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=18,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/tomes/astral/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=18,kazzmc.wp_cd20=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/tomes/astral/insufficient_xp

  #Dragon's End
execute if entity @s[scores={kazzmc.wp_id_mainhand=19,kazzmc.wp_cd21=..0}] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..9}] if score @s kazzmc.xp_level matches 30.. run function kazz.magecraft:weapons/types/tomes/dragon/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=19,kazzmc.use_wp=1..},gamemode=creative] run function kazz.magecraft:weapons/types/tomes/dragon/start
execute if entity @s[scores={kazzmc.wp_id_mainhand=19,kazzmc.wp_cd21=..0,kazzmc.use_wp=1..}] run function kazz.magecraft:weapons/types/tomes/dragon/insufficient_xp

#Dual Wielding
  #Setup Scoreboard
scoreboard players set @s kazzmc.use_wp 1

  #Flare Tome - Offhand
execute if entity @s[scores={kazzmc.wp_id_offhand=15,kazzmc.use_wp=1..,kazzmc.wp_cd17=..0},tag=!kazzmc.wp17_wield] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..2}] run function kazz.magecraft:weapons/types/tomes/flare/start
execute if entity @s[scores={kazzmc.wp_id_offhand=15,kazzmc.use_wp=1..},gamemode=creative,tag=!kazzmc.wp17_wield] run function kazz.magecraft:weapons/types/tomes/flare/start
execute if entity @s[scores={kazzmc.wp_id_offhand=15,kazzmc.use_wp=1..,kazzmc.wp_cd17=..0},tag=!kazzmc.wp17_wield] run function kazz.magecraft:weapons/types/tomes/flare/insufficient_xp

  #Soulspark Tome - Offhand
execute if entity @s[scores={kazzmc.wp_id_offhand=16,kazzmc.use_wp=1..,kazzmc.wp_cd18=..0},tag=!kazzmc.wp18_wield] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..4}] run function kazz.magecraft:weapons/types/tomes/soulspark/start
execute if entity @s[scores={kazzmc.wp_id_offhand=16,kazzmc.use_wp=1..},gamemode=creative,tag=!kazzmc.wp18_wield] run function kazz.magecraft:weapons/types/tomes/soulspark/start
execute if entity @s[scores={kazzmc.wp_id_offhand=16,kazzmc.use_wp=1..,kazzmc.wp_cd18=..0},tag=!kazzmc.wp18_wield] run function kazz.magecraft:weapons/types/tomes/soulspark/insufficient_xp

  #Withering Tome - Offhand
execute if entity @s[scores={kazzmc.wp_id_offhand=17,kazzmc.use_wp=1..,kazzmc.wp_cd19=..0},tag=!kazzmc.wp19_wield] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..18}] if score @s kazzmc.xp_level matches 15.. run function kazz.magecraft:weapons/types/tomes/withering/start
execute if entity @s[scores={kazzmc.wp_id_offhand=17,kazzmc.use_wp=1..},gamemode=creative,tag=!kazzmc.wp19_wield] run function kazz.magecraft:weapons/types/tomes/withering/start
execute if entity @s[scores={kazzmc.wp_id_offhand=17,kazzmc.use_wp=1..,kazzmc.wp_cd19=..0},tag=!kazzmc.wp19_wield] run function kazz.magecraft:weapons/types/tomes/withering/insufficient_xp

  #Astral Codex - Offhand
execute if entity @s[scores={kazzmc.wp_id_offhand=18,kazzmc.use_wp=1..,kazzmc.wp_cd20=..0},tag=!kazzmc.wp20_wield] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..7}] if score @s kazzmc.xp_level matches 25.. run function kazz.magecraft:weapons/types/tomes/astral/start
execute if entity @s[scores={kazzmc.wp_id_offhand=18,kazzmc.use_wp=1..},gamemode=creative,tag=!kazzmc.wp20_wield] run function kazz.magecraft:weapons/types/tomes/astral/start
execute if entity @s[scores={kazzmc.wp_id_offhand=18,kazzmc.use_wp=1..,kazzmc.wp_cd20=..0},tag=!kazzmc.wp20_wield] run function kazz.magecraft:weapons/types/tomes/astral/insufficient_xp

  #Dragon's End - Offhand
execute if entity @s[scores={kazzmc.wp_id_offhand=19,kazzmc.use_wp=1..,kazzmc.wp_cd21=..0},tag=!kazzmc.wp21_wield] unless entity @s[scores={kazzmc.xp_level=0,kazzmc.xp_point=..9}] if score @s kazzmc.xp_level matches 30.. run function kazz.magecraft:weapons/types/tomes/dragon/start
execute if entity @s[scores={kazzmc.wp_id_offhand=19,kazzmc.use_wp=1..},gamemode=creative,tag=!kazzmc.wp21_wield] run function kazz.magecraft:weapons/types/tomes/dragon/start
execute if entity @s[scores={kazzmc.wp_id_offhand=19,kazzmc.use_wp=1..,kazzmc.wp_cd21=..0},tag=!kazzmc.wp21_wield] run function kazz.magecraft:weapons/types/tomes/dragon/insufficient_xp

#Reset Scoreboard
scoreboard players set @s kazzmc.use_wp 0
scoreboard players reset @s kazzmc.wp_id_mainhand
scoreboard players reset @s kazzmc.wp_id_offhand

#Remove Dual Wielding Tags
tag @s remove kazzmc.wp17_wield
tag @s remove kazzmc.wp18_wield
tag @s remove kazzmc.wp19_wield
tag @s remove kazzmc.wp20_wield
tag @s remove kazzmc.wp21_wield