#Fetches Weapon ID
function kazz.magecraft:weapons/category/technical/get_id/mainhand
function kazz.magecraft:weapons/category/technical/get_id/offhand

#Fetches XP Data
execute store result score @s kazzmc.xp_point run xp query @s points
execute store result score @s kazzmc.xp_level run xp query @s levels



#Weapon Skills - Offhand
  #Gemspark Blade
execute if score @s kazzmc.wp_id_offhand matches 21 unless entity @s[tag=kazzmc.wp23_skilluser] unless entity @s[scores={kazzmc.xp_level=..4,kazzmc.xp_point=..29}] run function kazz.magecraft:weapons/types/swords/gemspark_blade/skill/start

  #Emerald Saber
execute if score @s kazzmc.wp_id_offhand matches 22 unless entity @s[tag=kazzmc.wp24_skilluser] unless entity @s[scores={kazzmc.xp_level=..9,kazzmc.xp_point=..39}] run function kazz.magecraft:weapons/types/swords/emerald_saber/skill/start

  #Flame Saber
execute if score @s kazzmc.wp_id_offhand matches 23 unless entity @s[tag=kazzmc.wp25_skilluser] unless entity @s[scores={kazzmc.xp_level=..19,kazzmc.xp_point=..79}] run function kazz.magecraft:weapons/types/swords/flame_saber/skill/check

  #Obsidiana
execute if score @s kazzmc.wp_id_offhand matches 24 unless entity @s[tag=kazzmc.wp26_skilluser] unless entity @s[scores={kazzmc.xp_level=..19,kazzmc.xp_point=..99}] run function kazz.magecraft:weapons/types/swords/obsidiana/skill/start

  #Sculk Seeker
execute if score @s kazzmc.wp_id_offhand matches 25 unless entity @s[tag=kazzmc.wp27_skilluser] unless entity @s[scores={kazzmc.xp_level=..24,kazzmc.xp_point=..99}] run function kazz.magecraft:weapons/types/swords/sculk_seeker/skill/start

  #Enderstrike
execute if score @s kazzmc.wp_id_offhand matches 26 unless entity @s[tag=kazzmc.wp28_skilluser] unless entity @s[scores={kazzmc.xp_level=..24,kazzmc.xp_point=..89}] run function kazz.magecraft:weapons/types/swords/enderstrike/skill/start

  #Amethyst Axe
execute if score @s kazzmc.wp_id_offhand matches 28 unless entity @s[tag=kazzmc.wp30_skilluser] unless entity @s[scores={kazzmc.xp_level=..0,kazzmc.xp_point=..9}] run function kazz.magecraft:weapons/types/axes/amethyst_axe/skill/start

  #Echoing Hatchet
execute if score @s kazzmc.wp_id_offhand matches 29 unless entity @s[tag=kazzmc.wp31_skilluser] unless entity @s[scores={kazzmc.xp_level=..9,kazzmc.xp_point=..14}] run function kazz.magecraft:weapons/types/axes/echoing_hatchet/skill/start

  #Riftspace Battle Axe
execute if score @s kazzmc.wp_id_offhand matches 30 unless entity @s[tag=kazzmc.wp32_skilluser] unless entity @s[scores={kazzmc.xp_level=..29,kazzmc.xp_point=..54}] run function kazz.magecraft:weapons/types/axes/riftspace_battle_axe/skill/start

  #Blazing Halberd
execute if score @s kazzmc.wp_id_offhand matches 31 unless entity @s[tag=kazzmc.wp33_skilluser] unless entity @s[scores={kazzmc.xp_level=..24,kazzmc.xp_point=..39}] run function kazz.magecraft:weapons/types/axes/blazing_halberd/skill/start



#Weapon Skills - Mainhand
  #Gemspark Blade
execute if entity @s[tag=kazzmc.wp23_skilluser] if score @s kazzmc.wp_id_mainhand matches 21 unless score @s kazzmc.wp_id_offhand matches 21 run tag @s remove kazzmc.wp23_skilluser

  #Emerald Saber
execute if entity @s[tag=kazzmc.wp24_skilluser] if score @s kazzmc.wp_id_mainhand matches 22 unless score @s kazzmc.wp_id_offhand matches 22 run tag @s remove kazzmc.wp24_skilluser

  #Flame Saber
execute if entity @s[tag=kazzmc.wp25_skilluser] if score @s kazzmc.wp_id_mainhand matches 23 unless score @s kazzmc.wp_id_offhand matches 23 run tag @s remove kazzmc.wp25_skilluser

  #Obsidiana
execute if entity @s[tag=kazzmc.wp26_skilluser] if score @s kazzmc.wp_id_mainhand matches 24 unless score @s kazzmc.wp_id_offhand matches 24 run tag @s remove kazzmc.wp26_skilluser

  #Sculk Seeker
execute if entity @s[tag=kazzmc.wp27_skilluser] if score @s kazzmc.wp_id_mainhand matches 25 unless score @s kazzmc.wp_id_offhand matches 25 run tag @s remove kazzmc.wp27_skilluser

  #Enderstrike
execute if entity @s[tag=kazzmc.wp28_skilluser] if score @s kazzmc.wp_id_mainhand matches 26 unless score @s kazzmc.wp_id_offhand matches 26 run tag @s remove kazzmc.wp28_skilluser

  #Amethyst Axe
execute if entity @s[tag=kazzmc.wp30_skilluser] if score @s kazzmc.wp_id_mainhand matches 28 unless score @s kazzmc.wp_id_offhand matches 28 run tag @s remove kazzmc.wp30_skilluser

  #Echoing Hatchet
execute if entity @s[tag=kazzmc.wp31_skilluser] if score @s kazzmc.wp_id_mainhand matches 29 unless score @s kazzmc.wp_id_offhand matches 29 run tag @s remove kazzmc.wp31_skilluser

  #Riftspace Battle Axe
execute if entity @s[tag=kazzmc.wp32_skilluser] if score @s kazzmc.wp_id_mainhand matches 30 unless score @s kazzmc.wp_id_offhand matches 30 run tag @s remove kazzmc.wp32_skilluser

  #Blazing Halberd
execute if entity @s[tag=kazzmc.wp33_skilluser] if score @s kazzmc.wp_id_mainhand matches 31 unless score @s kazzmc.wp_id_offhand matches 31 run tag @s remove kazzmc.wp33_skilluser



#Reset Scoreboards
scoreboard players reset @s kazzmc.wp_id_mainhand
scoreboard players reset @s kazzmc.wp_id_offhand